{% extends "front/base_logged.html" %}
{% load i18n %}
{% load static %}
{% load render_table from django_tables2 %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Definir Condições de Fronteira" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "wizard/help_text/step_front.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
          Neste passo o utilizador terá a definir as fontes de forçamento para as fronteiras oceânicas, fluviais e fronteira atmosfera, entre as opções disponibilizadas.
        {% endblocktrans %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    {% if forcings_table %}
    <div class="row nopad">
        <h5><strong>{% trans 'Selecione uma ou mais fronteiras e defina um tipo e forçamento' %}</strong></h5>
    </div>

    <div class="row nopad resizableCols">
        <div class="col1">
            {% render_table forcings_table %}
            <button id="btn_define" class="btn btn-primary btn-sm"><strong>{% trans "Definir tipo e forçamento" %}</strong></button>
        </div>
        <div class="col2">
            {% include "wizard/map.html" %}
        </div>
    </div>
    {% endif %}

    <form class="form" method="post">{% csrf_token %}
        {% include "wizard/modal/forcingchoice.html" %}

        <div class="forms">
        {% if forcings_table %}
        {% for field in forms.1 %}
            {% if not 'hidden' in field %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endif %}
        {% endfor %}
        {% endif %}

        {% for field in forms.0 %}
            {% if not 'hidden' in field %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endif %}
        {% endfor %}
        </div>

        <div class="row btnmenu">
            <div class="col-xs-6">
                <button id="btn_prev" type="button" class="btn btn-default" data-step="12" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                    <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                </button>
                <button id="btn_restart" class="btn btn-default" data-step="11" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
            </div>
            <div class="col-xs-6 text-right">
                {% if request.session.last_step < step %}
                <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="10" data-intro="{% trans 'Prima o botão' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="10" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                    {% trans "Guardar alterações" %}
                </button>
                <button id="btn_next" class="btn btn-default" data-step="13" data-intro="{% trans 'Ou passos posteriores' %}">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    <!-- Load some extra resources -->
    <!-- JQuery UI - IMPORTANT - custom build without tooltip widget (conflict with Bootstrap) -->
    <link rel="stylesheet" href="{% static 'vendor/jquery/jquery-ui-1.12.1.min.css' %}">
    <script src="{% static 'vendor/jquery/jquery-ui-1.12.1.min.js' %}"></script>

    <script type="text/javascript">
        // Hover Forcing table row - highlight layer
        $('#forcings_table tbody tr').hover(function(e) {
            var bid = e.currentTarget.cells[1].innerText;
            var layer = boundariesLayer.getLayer(bid);
            if (layer) {
                layer.setStyle({
                  weight: 9,
                  opacity: 0.6,
                });
            }
            // Also update Map's Info Panel
            info.update(bid, 'B');
          }, function(e) {
            var bid = e.currentTarget.cells[1].innerText;
            var layer = boundariesLayer.getLayer(bid);
            if (layer) {
              layer.setStyle({
                weight: 4,
                opacity: 1,
              });
            }
            // Clear Map's Info Panel
            info.update();
          }
        );

        // Button Show Forcing modal form
        $('#btn_define').click(function(e){
            var selectedbid = [];
            var selbids = $('.selBID:checked');
            if (selbids.length == 0) {
                $('#msg_str').html('{% trans "Selecione uma ou mais fronteiras para definir tipo e forçamento." %}');
                $('#divModal_msg').modal('show');
                return;
            } else {
                selbids.each(function(i, obj){
                    selectedbid.push($(obj).attr('data-bid'));
                });
            }

            // Clear forcings form
            clear_forcings_form();

            // Change Form's labels
            var lbl = selectedbid.join();
            $('#bidLabel').html(lbl);
            $('#applyLabel').html("{% trans 'Definir' %}");

            // Disable from bids select the bids user has selected
            $('#id_bids option').each(function() {
                var val = $(this).val();
                if (val != "" && lbl.indexOf(val) > -1) {
                    $(this).attr('disabled', 'disabled');
                }
            });

            // Show modal form
            $('#divModal_forcing').modal('show');
        });

        // Toggle select/unselect row checkbox on table row click
        /* if not in use - row click now opens filled forcing form */
        $('#forcings_table tr').click(function(e){
            var chk = $(this).find('input:checkbox')[0];
            toggleBID(chk, 'row');
        });

        $('.selBID').click(function(e){
            toggleBID(this, '');
        });

        $('#btn_apply').click(function(e){
            e.preventDefault();

            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            var flag = true;
            var msg = '';
            var months = ['{% trans "Jan" %}', '{% trans "Fev" %}', '{% trans "Mar" %}', '{% trans "Abr" %}', '{% trans "Mai" %}',
            '{% trans "Jun" %}', '{% trans "Jul" %}', '{% trans "Ago" %}', '{% trans "Set" %}', '{% trans "Out" %}',
                '{% trans "Nov" %}', '{% trans "Dez" %}'];

            console.log($("input[name='ftype']:checked")[0]);

            var ftype_text = $("input[name='ftype']:checked")[0].parentElement.innerText;

            console.log(ftype_text);

            var ftype = $("input[name='ftype']:checked").val();
            if (ftype == 'river') {
                var fmodel_text = [];
                msg = '{% trans "Para fronteiras fluviais terá de preencher o(s) campo(s) da opção selecionada para as condições climatológicas." %}';
                msg1 = '{% trans "Para fronteiras fluviais terá de preencher o(s) campo(s) da opção selecionada para as condições climatológicas para todas as variáveis." %}';
                msg2 = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';

                // Flux
                var vals_flux = [];
                var flux_input = $("input[name='flux_input']:checked").val();
                if (flux_input == 'annual') {
                    // Annual option was selected
                    var field = $('#id_flux13');
                    // Check if value exists and is valid
                    if (field.val() == '' || !field[0].validity.valid) {
                        flag = false;
                        field.focus();
                        {% if "3d" in baroclinic_type %}
                        activateTab("flux");
                        msg = msg1;
                        {% endif %}
                        if (!field[0].validity.valid) msg = msg2;
                    } else {
                        vals_flux.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                    }
                } else if (flux_input == 'monthly') {
                    for (var index = 1; index < 13; ++index) {
                        var field = $('#id_flux' + index);
                        if (field.val() == '' || !field[0].validity.valid) {
                            flag = false;
                            field.focus();
                            {% if "3d" in baroclinic_type %}
                            activateTab("flux");
                            msg = msg1;
                            {% endif %}
                            if (!field[0].validity.valid) msg = msg2;
                            break;
                        }
                        vals_flux.push(months[index-1] + ':' + field.val().replace(',', '.'));
                    }
                    vals_flux = "[" + vals_flux.join(", ") + "]";
                } else if (flux_input == 'percent') {
                    var field = $('#id_bid_perc');
                    var field_aux = $('#id_bids');
                    if (field.val() == '' || field_aux.val() == "" || field_aux.val() == null || !field[0].validity.valid) {
                        flag = false;
                        field.focus();
                        {% if "3d" in baroclinic_type %}
                        activateTab("flux");
                        msg = msg1;
                        {% endif %}
                        if (!field[0].validity.valid) msg = msg2;
                    } else {
                        vals_flux.push(field.val() + '% ' + field_aux.val());
                    }
                } else if (flux_input == 'url') {
                    var field = $('#id_url');
                    if (field.val().indexOf("http://") == -1) {
                        msg = '{% trans "Erro ao validar campo do tipo URL." %}';
                        flag = false;
                    } else {
                        vals_flux.push(field.val());
                    }
                }
                {% if "2d" in baroclinic_type %}
                fmodel_text.push(vals_flux.toString());
                {% else %}
                fmodel_text.push("{% trans "Fluxo" %}: " + vals_flux.toString());
                {% if "3d" in baroclinic_type %}
                if (flag) {
                    // Temperature
                    var vals_temp = [];
                    var temp_input = $("input[name='temp_input']:checked").val();
                    if (temp_input == 'annual') {
                        // Annual option was selected
                        var field = $('#id_temp13');
                        // Check if value exists and is valid
                        if (field.val() == '' || !field[0].validity.valid) {
                            flag = false;
                            field.focus();
                            {% if "3d" in baroclinic_type %}
                            activateTab("temp");
                            msg = msg1;
                            {% endif %}
                            if (!field[0].validity.valid) msg = msg2;
                        } else {
                            vals_temp.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                        }
                    } else if (temp_input == 'monthly') {
                        for (var index = 1; index < 13; ++index) {
                            var field = $('#id_temp' + index);
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                {% if "3d" in baroclinic_type %}
                                activateTab("temp");
                                msg = msg1;
                                {% endif %}
                                if (!field[0].validity.valid) msg = msg2;
                                break;
                            }
                            vals_temp.push(months[index-1] + ':' + field.val().replace(',', '.'));
                        }
                        vals_temp = "[" + vals_temp.join(", ") + "]";
                    }
                    fmodel_text.push("{% trans "Temperatura" %}: " + vals_temp.toString());

                    if (flag) {
                        // Salinity
                        var vals_salt = [];
                        var salt_input = $("input[name='salt_input']:checked").val();
                        if (salt_input == 'annual') {
                            // Annual option was selected
                            var field = $('#id_salt13');
                            // Check if value exists and is valid
                            if (field.val() == '' || !field[0].validity.valid) {
                                flag = false;
                                field.focus();
                                {% if "3d" in baroclinic_type %}
                                activateTab("salt");
                                msg = msg1;
                                {% endif %}
                                if (!field[0].validity.valid) msg = msg2;
                            } else {
                                vals_salt.push('{% trans "anual" %}=' + field.val().replace(',', '.'));
                            }
                        } else if (salt_input == 'monthly') {
                            for (var index = 1; index < 13; ++index) {
                                var field = $('#id_salt' + index);
                                if (field.val() == '' || !field[0].validity.valid) {
                                    flag = false;
                                    field.focus();
                                    {% if "3d" in baroclinic_type %}
                                    activateTab("salt");
                                    msg = msg1;
                                    {% endif %}
                                    if (!field[0].validity.valid) msg = msg2;
                                    break;
                                }
                                vals_salt.push(months[index-1] + ':' + field.val().replace(',', '.'));
                            }
                            vals_salt = "[" + vals_salt.join(", ") + "]";
                        }
                        fmodel_text.push("{% trans "Salinidade" %}: " + vals_salt.toString());
                    }
                }
                {% endif %}
                {% endif %}
            }

            // Show error
            if (!flag) {
                $('#form_errors').html(msg);
                $("#form_errors").show();
            } else {
                // Update table client-side
                var bids = $('#bidLabel').html().split(',');
                for (var i = 0; i <bids.length; ++i) {
                    var sel_bid = bids[i];
                    var bidrow = $("#forcings_table td.bid:contains('" + sel_bid + "')").parent();
                    if (bidrow) {
                        var bid = bidrow[0].cells[1].innerText;
                        if (sel_bid == bid) {
                            bidrow[0].cells[2].innerText = ftype_text;
                            if (ftype == 'river') {
                                // Prettify long json
                                bidrow[0].cells[3].innerHTML = prettify(fmodel_text);
                            }
                        }
                    }
                }

                // Update all oceanic boundaries with oceanmodel input
                update_ocean_forcings();

                // Remove highlight from selected layers
                for (var i = 0; i < bids.length; ++i) {
                    var layer = boundariesLayer.getLayer(bids[i]);
                    if (layer) boundariesLayer.resetStyle(layer);
                }
                // Unselect all checkboxes in table
                $('.selBID:checked').prop("checked", false);
                // Close modal form
                $('#divModal_forcing').modal('hide');
            }
        });

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true, errors = [], error_str = '';
            var msg = '{% trans "Para continuar terá de:" %}' + '<br/>';

            try {
                // Validate boundary typology and water forcings
                var forcings = [];
                $('#forcings_table tbody tr').each(function(i, obj){
                    var bid = obj.cells[1].innerText;
                    var ftype = get_fType(obj.cells[2].innerText);
                    var fmodel = obj.cells[3].innerText;

                    // Validate if bids and their types are filled
                    if (bid == '' || ftype == '') {
                        flagok = false;
                        error_str = '{% trans "- atribuir uma tipologia para todas as fronteiras na tabela." %}';
                        if (errors.indexOf(error_str) === -1) errors.push(error_str);
                    }
                    // Validate if river types are filled
                    if (ftype == 'river' && fmodel == '') {
                        flagok = false;
                        error_str = '{% trans "- atribuir um forçamento para todas as fronteiras fluviais na tabela." %}';
                        if (errors.indexOf(error_str) === -1) errors.push(error_str);

                        // Validate if boundary referenced in percentage is also of type river
                        if (flagok && fmodel.indexOf("%") > -1) {
                            flagok = boundary_type_river(fmodel);
                            if (!flagok) {
                                error_str = '{% trans "- ter atenção que se usar uma percentagem de uma fronteira, como condição climatológica de outra, terá de a definir como fluvial." %}';
                                if (errors.indexOf(error_str) === -1) errors.push(error_str);
                            }
                        }
                    }
                    // Validate if ocean types are filled
                    if (ftype == 'ocean' && (fmodel == '' || fmodel.indexOf('---------') > -1)) {
                        flagok = false;
                        {% if baroclinic_type == "basic3d" %}
                        error_str = '{% trans "- selecionar forçamentos de Circulação, Temperatura e Salinidade a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% elif baroclinic_type == "basic3d" and "yes" in waves_type %}
                        error_str = '{% trans "- selecionar forçamentos de Circulação, Ondas, Temperatura e Salinidade a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% elif baroclinic_type == "basic2d" and "yes" in waves_type %}
                        error_str = '{% trans "- selecionar forçamentos de Circulação e Ondas a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% else %}
                        error_str = '{% trans "- selecionar um forçamento a aplicar a todas as fronteiras oceânicas na tabela." %}';
                        {% endif %}
                        if (errors.indexOf(error_str) === -1) errors.push(error_str);
                    }

                    // DePrettify long JSON
                    fmodel = deprettify(fmodel, ftype);
                    forcings.push({'bid': bid, 'ftype': ftype, 'fmodel': fmodel});
                });

                // Validate atmosferic forcings
                var atmmodel_input = $('#id_atmmodel').val();
                if (atmmodel_input == '') {
                    flagok = false;
                    error_str = '{% trans "- selecionar um forçamento atmosférico." %}';
                    errors.push(error_str);
                }

                if (!flagok) {
                    $('#msg_str').html(msg + errors.join('<br/>'));
                    $('#divModal_msg').modal('show');
                    return false;
                }

                $('#divModal_processing').modal('show');

                $('#id_forcings').val(JSON.stringify(forcings));
                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: $('.form').serialize(),
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data['msg']) {
                                $('#msg_str').html(data['msg']);
                                $('#divModal_msg').modal('show');
                            }
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        // On change update all oceanic boundaries
        $("#id_oceanmodel").change(function(e) {
            update_ocean_forcings();
        });

        {% if "yes" in waves_type %}
        $("#id_oceanmodel_waves").change(function(e) {
            update_ocean_forcings();
        });
        {% endif %}

        {% if "3d" in baroclinic_type %}
        $("#id_oceanmodel_temp_salt").change(function(e) {
            update_ocean_forcings();
        });
        // Commented separate forcings for Temperature ans Salinity, for this version use only one forcing for both
        /*
        $("#id_oceanmodel_temp").change(function(e) {
            update_ocean_forcings();
        });
        $("#id_oceanmodel_salt").change(function(e) {
            update_ocean_forcings();
        });
        */
        {% endif %}

        // Validate if boundary is defined as river
        function boundary_type_river(fmodel) {
            var out_flag = true;
            var arr = fmodel.split('\n');
            if (arr.length == 1) {
                // 2D
                var ref_bid = fmodel.split("% ")[1];
                $('#forcings_table tbody tr').each(function(i, obj){
                    if (obj.cells[1].innerText == ref_bid && get_fType(obj.cells[2].innerText) != 'river') {
                        out_flag = false;
                        return false;
                    }
                });
            } else {
                // 3D
                for (var i=0; i<arr.length; ++i) {
                    var obj = arr[i].split(":")[0];
                    var val = arr[i].substring(obj.length+1, arr[i].length);
                    if (val.indexOf("%") > -1) {
                        var ref_bid = val.split("% ")[1];
                        $('#forcings_table tbody tr').each(function(n, obj){
                            if (obj.cells[1].innerText == ref_bid && get_fType(obj.cells[2].innerText) != 'river') {
                                out_flag = false;
                                return false;
                            }
                        });
                    }
                }
            }
            return out_flag;
        }

        // Clear forcings form
        function clear_forcings_form() {
            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            // Activate Ocean tab
            $("input[name='ftype'][value='ocean']").prop('checked', true);
            $("input[name='ftype'][value='ocean']").trigger('change');

            // Activate Flux tab for river conditions
            $("input[name='flux_input'][value='annual']").prop('checked', true);
            $(".nav-pills a[href='#flux']").tab('show');

            // Clear river inputs
            for (var index = 1; index <= 13; ++index) {
                $('#id_flux' + index).val('');
                {% if "3d" in baroclinic_type %}
                $('#id_temp' + index).val('');
                $('#id_salt' + index).val('');
                {% endif %}
            }
            $('#id_url').val('');
            $('#id_bid_perc').val('');
            // Clear and enable bids options
            $('#id_bids option').each(function() {
                $(this).removeAttr('disabled');
            });
            $('#id_bids option:selected').prop('selected', false);
            {% if "3d" in baroclinic_type %}
            $("input[name='temp_input'][value='annual']").prop('checked', true);
            $("input[name='salt_input'][value='annual']").prop('checked', true);
            {% endif %}
        }

        function get_fType(text) {
            var outvalue = '';
            $("input[name='ftype']").each(function(){
                if (this.parentElement.innerText.indexOf(text) > -1) {
                    outvalue = this.value;
                }
            });
            return outvalue;
        }

        // Toggle BID selection
        function toggleBID(chk, ev) {
            // Toggle checked state if click fired from row
            if (ev == 'row') chk.checked = !chk.checked;

            var bid = $(chk).attr('data-bid');
            if (chk.checked) {
                // Change layer's style on map
                var layer = boundariesLayer.getLayer(bid);
                if (layer) {
                    layer.setStyle({
                      color: "black",
                      dashArray: '30 10',
                    });
                }
            } else {
                var layer = boundariesLayer.getLayer(bid);
                if (layer) boundariesLayer.resetStyle(layer);
            }
        }

        // DePrettify long JSON
        function deprettify(string, type) {
            var out = {};
            var fmodeltype = "string";

            var arr = string.split('\n');
            for (var i = 0; i < arr.length; ++i) {
                if (arr[i].indexOf(':') > -1) {
                    // multiple objects
                    var obj = arr[i].split(":")[0];
                    var val = arr[i].substring(obj.length+1, arr[i].length); // Get the rest of the string
                } else {
                    if(type == 'river')
                        var obj = "flow";
                    else
                        var obj = "circulation";
                    var val = arr[i];
                }

                if (type == 'river') {
                    if (val.indexOf('[') >= 0) {
                        // Monthly
                        var sarray = val.replace("[", "").replace("]", "").split(', ');
                        var oarray = [];
                        for (var j=0; j<sarray.length; j++) {
                            oarray.push(parseFloat(sarray[j].split(":")[1]));
                        }
                        out[obj] = {'type': 'monthly', 'value': oarray};
                    } else if (val.indexOf('http') >= 0) {
                        // Url
                        out[obj] = {'type': 'url', 'value': val};
                    } else if (val.indexOf('=') >= 0) {
                        // Annual
                        out[obj] = {'type': 'annual', 'value': parseFloat(val.split("=")[1])};
                    } else if (val.indexOf('%') >= 0) {
                        // Percent
                        var oarray = val.split("% ");
                        out[obj] = {'type': 'percent', 'value': {'percent': parseFloat(oarray[0]), 'bid': oarray[1]}};
                    }
                } else {
                    out[obj] = {'type': 'string', 'value': val};
                }
            }
            return out;
        }

        // Prettify long JSON
        function prettify(json) {
            var out = "";
            for (var i = 0; i < json.length; ++i) {
                var obj = JSON.stringify(json[i], null, ' ');
                if (i == json.length - 1) {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "");
                } else {
                    out += obj.replace(/"/g, "").replace("{", "").replace("}", "") + '<br>';
                }
            }
            return out;
        }

        // Update all oceanic boundaries with oceanmodel input
        function update_ocean_forcings() {
            var strval = "";
            
            {% if baroclinic_type == "basic2d" %}
                {% if "no" in waves_type %}
                    strval = $("#id_oceanmodel").find("option:selected").text();
                {% endif %}
                {% if "yes" in waves_type %}
                    strval = '{% trans "Circulação" %}' + ': ' + $("#id_oceanmodel").find("option:selected").text() + '<br>';
                    strval += '{% trans "Ondas" %}' + ': ' + $("#id_oceanmodel_waves").find("option:selected").text();
                {% endif %}
            {% else %}
            strval = '{% trans "Circulação" %}' + ': ' + $("#id_oceanmodel").find("option:selected").text() + '<br>';
            {% endif %}

            {% if "yes" in waves_type %}
            strval += '{% trans "Ondas" %}' + ': ' + $("#id_oceanmodel_waves").find("option:selected").text();
            {% endif %}

            {% if "yes" in waves_type and "3d" in baroclinic_type %}
            strval += '<br>';
            {% endif %}

            {% if "3d" in baroclinic_type %}
            strval += '{% trans "Temperatura" %}' + ': ' + $("#id_oceanmodel_temp_salt").find("option:selected").text() + '<br>';
            strval += '{% trans "Salinidade" %}' + ': ' + $("#id_oceanmodel_temp_salt").find("option:selected").text();

            // Commented separate forcings for Temperature ans Salinity, for this version use only one forcing for both
            //strval += '{% trans "Temperatura" %}' + ': ' + $("#id_oceanmodel_temp").find("option:selected").text() + '<br>';
            //strval += '{% trans "Salinidade" %}' + ': ' + $("#id_oceanmodel_salt").find("option:selected").text();
            {% endif %}

            $('#forcings_table tbody tr').each(function(i, obj){
                var ftype = get_fType(obj.cells[2].innerText);
                if (ftype == 'ocean')
                    obj.cells[3].innerHTML = strval;
            });
        }

        {% if "3d" in baroclinic_type %}
        // Activate Tab in forcing form
        function activateTab(tab) {
            // if link enabled show tab
            if (!$('.nav-pills a[href="#' + tab + '"]').hasClass("disabled")) {
                $('.nav-pills a[href="#' + tab + '"]').tab('show');
            }
        }
        {% endif %}

        // Tooltips Setup (for Intro.js)
        $('#forcings_table td:first').parent().attr("data-step", 5);
        $('#forcings_table td:first').parent().attr("data-intro", "{% trans 'Selecione uma ou mais fronteiras da tabela' %}");

        $('#btn_define').attr("data-step", 6);
        $('#btn_define').attr("data-intro", "{% trans 'Prima o botão e defina o seu tipo e suas condições de fronteira a partir do formulário' %}");

        $('#forcings_table').parent().attr("data-step", 7);
        $('#forcings_table').parent().attr("data-intro", "{% trans 'Repita até definir o tipo de todas as fronteiras e forçamentos fluviais' %}");

        $('#id_oceanmodel').attr("data-step", 8);
        $('#id_oceanmodel').attr("data-intro", "{% trans 'Selecione um forçamento a aplicar às fronteiras oceânicas se existirem' %}");

        $('#id_atmmodel').attr("data-step", 9);
        $('#id_atmmodel').attr("data-intro", "{% trans 'Selecione um forçamento atmosférico' %}");

        // On Document Ready
        $(function(){
            // Hide error panel
            $('#form_errors').hide();

            // Set Table as resizable
            $(".resizableCols .col1").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: 600,
                resize: function() {
                  $('.col1').css('width', $('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth() + '%');
                  $('.col2').css('width', 100 - ($('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth()) + '%');
                  map.invalidateSize(false);
                }
            });

            // Add bootstrap behavior to 'ftype' radio inputs to work as tab controller
            $("input[name='ftype']").each(function() {
                console.log("oioi");
                $(this).attr({'data-target': "#" + $(this).val()});
            });

            // On 'ftype' change work as tab controller
            $("input[name='ftype']").change(function() {
                $(this).tab('show');
                $(this).blur();

                $("#form_errors").hide();
                $('#form_errors').html('');
            });
        });
    </script>

{% endblock content %}
